package model;

public class Registration {
	
	private String course;
	private int credits;
	private int marks;
	
	public Registration(String course, int credits, int marks) {
		this.course = course;
		this.credits = credits;
		this.marks = marks;
	}
	
	public Registration(String course, int credits) {
//		this.course = course;
//		this.credits = credits;
		this(course, credits, 0);
	}
	
	public void setMarks(int marks) {
		this.marks = marks; 
	}
	
	public String getCourseName() {
		return this.course;
	}
	
	public int getNumberOfCredits() {
		return this.credits;
	}
	
	public int getMarks() {
		return this.marks;
	} 
	
	/* Here is the map from numerical raw marks to string letter grades:
	 * Marks >= 90			: "A+"
	 * 80 <= Marks <  90	: "A"
	 * 70 <= Marks <  80	: "B"
	 * 60 <= Marks <  70	: "C"
	 * 50 <= Marks <  60	: "D"
	 * Marks < 50			: "F"
	 */
	public String getLetterGrade() {
		String lg  = null;
		
		if(this.marks >= 90) {
			lg = "A+";
		}
		else if(this.marks >= 80) {
			lg = "A";
		}
		else if(this.marks >= 70) {
			lg = "B";
		}
		else if(this.marks >= 60) {
			lg = "C";
		}
		else if(this.marks >= 50) {
			lg = "D";
		}
		else { // this.marks < 50
			lg = "F";
		}
		
		return lg;
	}
	
	public int getWeightedGradePoint() {
		/*
		 * WGP = GP * Credits
		 */
		String lg = this.getLetterGrade(); // calling some method in the same class
		int gp = 0;
		
		if(lg.equals("A+")) {
			gp = 9;
		}
		else if(lg.equals("A")) {
			gp = 8;
		}
		else if(lg.equals("B")) {
			gp = 7;
		}
		else if(lg.equals("C")) {
			gp = 6;
		}
		else if(lg.equals("D")) {
			gp = 5;
		}
		else { // lg.equals("F")
			gp = 0;
		}
		return gp * this.credits;
	}
}












