package model;

public class Transcript {
	private String name;
	private final int MAX_NUMBER_OF_REGISTRATIONS = 60;
	private Registration[] registrations;
	private int nor; // number of registrations
	
	public Transcript(String name) {
		this.name = name;
		this.registrations = new Registration[MAX_NUMBER_OF_REGISTRATIONS];
		this.nor = 0;
	}
	
	public void addRegistration(Registration r) {
		this.registrations[this.nor] = r;
		this.nor ++;
	}
	
	public void addRegistration(String name, int credits) {
//		Registration r = new Registration(name, credits);
//		this.addRegistration(r);
		this.addRegistration(new Registration(name, credits));
	}
	
	public void addRegistrations(Registration[] array) {
		for(int i = 0; i < array.length; i ++) {
//			Registration r = array[i];
//			this.addRegistration(r); 
			this.addRegistration(array[i]);
		}
	}
	
	public Registration[] getReport() {
		// the length of the returned array should correspond to 
		// the number of registration objects stored in `registrations` array.
		Registration[] report = new Registration[this.nor];
		for(int i = 0; i < this.nor; i ++) {
			report[i] = this.registrations[i];
		}
		return report;
	}
	
	public int getMarks(String course) {
		int marks = -1;
		
//		for(int i = 0; i < this.nor; i ++) {
//			if(this.registrations[i].getCourseName().equals(course)) {
//				marks = this.registrations[i].getMarks();
//			}
//		}
		
		for(int i = 0; i < this.nor; i ++) {
			Registration r = this.registrations[i];
			if(r.getCourseName().equals(course)) {
				marks = r.getMarks();
			}
		}
		
		return marks;
	}
	
	public void setMarks(String course, int marks) {
		for(int i = 0; i < this.nor; i ++) {
			Registration r = this.registrations[i];
			if(r.getCourseName().equals(course)) {
				r.setMarks(marks);
			}
		}
		// Exercise: how to get rid of the smell (code duplicates) from getMarks and setMarks?
	}
	
	public double getWeightedGPA() {
		int wgps = 0; // total number of weighted grade points
		for(int i = 0; i < this.nor; i ++) {
			wgps += this.registrations[i].getWeightedGradePoint();
		}
		
		// this is wrong: dividing an integer by another integer will only give quotient.
		// 5 / 2 == 2
//		return wgps / this.nor;
		
		return ((double) wgps) / this.nor;
	}
}







